<template>
  <div
    class="wrapper gallery-wrapper"
    v-waypoint="{active: isWaypointActive, callback: animate, options: {threshold: [0.25, 1]}}"
  >
    <div class="container">
      <div class="gallery">
        <header class="gallery-header">
          <div class="gallery__title">
            Our gallery
          </div>
          <CommonGradient class="gallery__gradient"/>
        </header>
        <main class="gallery-main">
          <div
            class="gallery-row"
            v-for="(row, rowIdx) in gallery"
            :key="rowIdx"
          >
            <div
              class="gallery__image"
              v-for="(img, imgIdx) in row"
              :key="imgIdx"
              :style="`background-image: url(${img})`"
            />
          </div>
        </main>
        <div class="btn btn_green-filled gallery__btn">
          Try yourself
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import CommonGradient from "@/components/common/CommonGradient";
import isMobilePlatform from "@/utils";

export default {
  name: "MainPageGallery",
  components: {CommonGradient},
  data() {
    return {
      gallery: [
        [require('@/assets/images/gallery/gallery_photo_1.jpg'), require('@/assets/images/gallery/gallery_photo_2.jpg')],
        [require('@/assets/images/gallery/gallery_photo_3.jpg'), require('@/assets/images/gallery/gallery_photo_4.jpg')],
        [require('@/assets/images/gallery/gallery_photo_5.jpg'), require('@/assets/images/gallery/gallery_photo_6.jpg')],
      ],
      isWaypointActive: true
    }
  },
  methods: {
    animate({going}) {
      const isMobile = isMobilePlatform()
      if (going !== 'in') return

      const tl = this.$anime.timeline({
        easing: 'easeOutSine'
      })

      if (!isMobile) {
        tl
          .add({
            targets: '.gallery-wrapper',
            backgroundSize: ['150%', '100%'],
            opacity: [.5, 1],
            duration: 500,
          })
      }
      tl
        .add({
          targets: '.gallery__title',
          opacity: [0, 1],
          duration: 500,
          translateY: [-100, 0],
        })
        tl.add({
            targets: '.gallery__gradient',
            duration: 500,
            width: [0, '100%']
          })

        tl
        .add({
          targets: '.gallery__image',
          delay: function (el, i) {return i * 300},
          duration: 750,
          opacity: [0, 1],
          scale: [1.2, 1],
          translateX: [-100, 0]
        })
        .add({
          targets: '.gallery__btn',
          duration: 300,
          opacity: [0, 1],
          translateY: [100, 0]
        })


      this.isWaypointActive = false
    },
  }
}
</script>

<style scoped lang="sass">
@import "~@/assets/sass/components/MainPage/MainPageGallery.sass"
</style>
